unit DataModuleu;

interface

uses
  System.SysUtils, System.Classes, Data.DB, Datasnap.DBClient;

type
  TDataModule1 = class(TDataModule)
    CustomerCDS: TClientDataSet;
    OrdersCDS: TClientDataSet;
    PartsCDS: TClientDataSet;
    CustomerDataSource: TDataSource;
    ItemsCDS: TClientDataSet;
    OrdersSource: TDataSource;
    ItemsSource: TDataSource;
    PartsSource: TDataSource;
    EmployeeCDS: TClientDataSet;
    CountryCDS: TClientDataSet;
    EmployeeSource: TDataSource;
    CountrySource: TDataSource;
    procedure DataModuleCreate(Sender: TObject);
    procedure CustomerCDSAddressGetText(Sender: TField; var Text: string;
      DisplayText: Boolean);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure ResetDataSets;
  end;

var
  DataModule1: TDataModule1;

implementation

{%CLASSGROUP 'System.Classes.TPersistent'}

{$R *.dfm}

procedure TDataModule1.CustomerCDSAddressGetText(Sender: TField;
  var Text: string; DisplayText: Boolean);
var
  cds: TClientDataSet;
const
  crlf = #13#10;
begin
//This event handler is not invoked when the field is read by FastReport
  cds := TClientDataSet(Sender.DataSet);
  if cds.FieldByName('Addr2').IsNull then
    Text := cds.FieldByName('Addr1').Value
  else
    Text := cds.FieldByName('Addr1').Value + crlf +
      cds.FieldByName('Addr2').Value;
end;

procedure TDataModule1.DataModuleCreate(Sender: TObject);
begin
  ResetDataSets;
  CustomerCDS.FieldByName('Addr1').OnGetText := CustomerCDSAddressGetText;
end;

procedure TDataModule1.ResetDataSets;
begin
  CustomerCDS.IndexFieldNames := '';
  CustomerCDS.MasterSource := nil;
  CustomerCDS.MasterFields := '';
  OrdersCDS.IndexFieldNames := '';
  OrdersCDS.MasterSource := nil;
  OrdersCDS.MasterFields := '';
  ItemsCDS.IndexFieldNames := '';
  ItemsCDS.MasterSource := nil;
  ItemsCDS.MasterFields := '';
  PartsCDS.IndexFieldNames := '';
  PartsCDS.MasterSource := nil;
  PartsCDS.MasterFields := '';
  EmployeeCDS.IndexFieldNames := '';
  EmployeeCDS.MasterSource := nil;
  EmployeeCDS.MasterFields := '';
  CountryCDS.IndexFieldNames := '';
  CountryCDS.MasterSource := nil;
  CountryCDS.MasterFields := '';
end;

end.
